Index: src/main/groovy/org/gradle/groovy/scripts/ImportsScriptSource.java
===================================================================
--- src/main/groovy/org/gradle/groovy/scripts/ImportsScriptSource.java	(revision 1596)
+++ src/main/groovy/org/gradle/groovy/scripts/ImportsScriptSource.java	(working copy)
@@ -1,63 +1,67 @@
-/*
- * Copyright 2008 the original author or authors.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *      http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-package org.gradle.groovy.scripts;
-
-import org.gradle.api.internal.project.ImportsReader;
-import org.gradle.util.GUtil;
-
-import java.io.File;
-
-public class ImportsScriptSource implements ScriptSource {
-    private final ScriptSource source;
-    private final ImportsReader importsReader;
-    private final File rootDir;
-
-    public ImportsScriptSource(ScriptSource source, ImportsReader importsReader, File rootDir) {
-        this.source = source;
-        this.importsReader = importsReader;
-        this.rootDir = rootDir;
-    }
-
-    public ScriptSource getSource() {
-        return source;
-    }
-
-    public String getText() {
-        String text = source.getText();
-        assert text != null;
-
-        String imports;
-        if (text.length() > 0) {
-            imports = '\n' + importsReader.getImports(rootDir);
-        } else {
-            imports = "";
-        }
-
-        return text + imports;
-    }
-
-    public String getClassName() {
-        return source.getClassName();
-    }
-
-    public File getSourceFile() {
-        return source.getSourceFile();
-    }
-
-    public String getDisplayName() {
-        return source.getDisplayName();
-    }
-}
+/*
+ * Copyright 2008 the original author or authors.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+package org.gradle.groovy.scripts;
+
+import org.gradle.api.internal.project.ImportsReader;
+import org.gradle.util.GUtil;
+
+import java.io.File;
+
+public class ImportsScriptSource implements ScriptSource {
+    private final ScriptSource source;
+    private final ImportsReader importsReader;
+    private final File rootDir;
+
+    public ImportsScriptSource(ScriptSource source, ImportsReader importsReader, File rootDir) {
+        this.source = source;
+        this.importsReader = importsReader;
+        this.rootDir = rootDir;
+    }
+
+    public ScriptSource getSource() {
+        return source;
+    }
+
+    public String getText() {
+        String text = source.getText();
+        assert text != null;
+
+        String imports;
+        if (text.length() > 0) {
+            imports = '\n' + importsReader.getImports(rootDir);
+        } else {
+            imports = "";
+        }
+
+        return text + imports;
+    }
+
+    public String getClassName() {
+        return source.getClassName();
+    }
+
+    public File getSourceFile() {
+        return source.getSourceFile();
+    }
+
+    public String getSourceFileCanonicalPath() {
+        return source.getSourceFileCanonicalPath();
+    }
+
+    public String getDisplayName() {
+        return source.getDisplayName();
+    }
+}
Index: src/main/groovy/org/gradle/groovy/scripts/ScriptCompilationHandler.java
===================================================================
--- src/main/groovy/org/gradle/groovy/scripts/ScriptCompilationHandler.java	(revision 1596)
+++ src/main/groovy/org/gradle/groovy/scripts/ScriptCompilationHandler.java	(working copy)
@@ -1,37 +1,38 @@
-/*
- * Copyright 2007-2008 the original author or authors.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *      http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-package org.gradle.groovy.scripts;
-
-import groovy.lang.Script;
-
-import java.io.File;
-
-import org.codehaus.groovy.control.CompilationUnit;
-
-/**
- * @author Hans Dockter
- */
-public interface ScriptCompilationHandler {
-    <T extends Script> T createScriptOnTheFly(ScriptSource source, ClassLoader classLoader,
-                                              CompilationUnit.SourceUnitOperation transformer,
-                                              Class<T> scriptBaseClass);
-
-    void writeToCache(ScriptSource source, ClassLoader classLoader, File scriptCacheDir,
-                      CompilationUnit.SourceUnitOperation transformer, Class<? extends Script> scriptBaseClass);
-
-    <T extends Script> T loadFromCache(ScriptSource source, ClassLoader classLoader, File scriptCacheDir,
-                                       Class<T> scriptBaseClass);
-}
+/*
+ * Copyright 2007-2008 the original author or authors.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+package org.gradle.groovy.scripts;
+
+import groovy.lang.Script;
+
+import java.io.File;
+import java.util.List;
+
+import org.codehaus.groovy.control.CompilationUnit;
+
+/**
+ * @author Hans Dockter
+ */
+public interface ScriptCompilationHandler {
+    <T extends Script> T createScriptOnTheFly(ScriptSource source, ClassLoader classLoader,
+                                              List transformers,
+                                              Class<T> scriptBaseClass);
+
+    void writeToCache(ScriptSource source, ClassLoader classLoader, File scriptCacheDir,
+                      List transformers, Class<? extends Script> scriptBaseClass);
+
+    <T extends Script> T loadFromCache(ScriptSource source, ClassLoader classLoader, File scriptCacheDir,
+                                       Class<T> scriptBaseClass);
+}
Index: src/main/groovy/org/gradle/groovy/scripts/ScriptProcessor.java
===================================================================
--- src/main/groovy/org/gradle/groovy/scripts/ScriptProcessor.java	(revision 1596)
+++ src/main/groovy/org/gradle/groovy/scripts/ScriptProcessor.java	(working copy)
@@ -1,38 +1,48 @@
-/*
- * Copyright 2009 the original author or authors.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *      http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-package org.gradle.groovy.scripts;
-
-import org.codehaus.groovy.control.CompilationUnit;
-
-/**
- * Compiles a script into an executable {@code Script} object.
- */
-public interface ScriptProcessor {
-    /**
-     * Sets the parent classloader for the script. Can be null.
-     */
-    ScriptProcessor setClassloader(ClassLoader classloader);
-
-    /**
-     * Sets the transformer to use to compile the script. Can be null.
-     */
-    ScriptProcessor setTransformer(CompilationUnit.SourceUnitOperation transformer);
-
-    /**
-     * Compiles the script into a {@code Script} object of the given type.
-     */
-    <T extends ScriptWithSource> T process(Class<T> scriptType);
-}
+/*
+ * Copyright 2009 the original author or authors.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+package org.gradle.groovy.scripts;
+
+import org.codehaus.groovy.control.CompilationUnit;
+
+/**
+ * Compiles a script into an executable {@code Script} object.
+ */
+public interface ScriptProcessor {
+    /**
+     * Sets the parent classloader for the script. Can be null.
+     */
+    ScriptProcessor setClassloader(ClassLoader classloader);
+
+    /**
+     * Removes all transformers to use to compile the script.
+     */
+    ScriptProcessor clearTransformers();
+
+    /**
+     * Adds the transformer to use to compile the script. Cannot be null.
+     */
+    ScriptProcessor addTransformer(CompilationUnit.SourceUnitOperation transformer);
+
+    /**
+     * Adds the transformer to use to compile the script. Cannot be null.
+     */
+    ScriptProcessor addTransformer(CompilationUnit.PrimaryClassNodeOperation transformer);
+
+    /**
+     * Compiles the script into a {@code Script} object of the given type.
+     */
+    <T extends ScriptWithSource> T process(Class<T> scriptType);
+}
Index: src/main/groovy/org/gradle/groovy/scripts/ScriptSource.java
===================================================================
--- src/main/groovy/org/gradle/groovy/scripts/ScriptSource.java	(revision 1596)
+++ src/main/groovy/org/gradle/groovy/scripts/ScriptSource.java	(working copy)
@@ -1,43 +1,48 @@
-/*
- * Copyright 2008 the original author or authors.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *      http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-package org.gradle.groovy.scripts;
-
-import java.io.File;
-
-/**
- * The source for the text of a script.
- */
-public interface ScriptSource {
-    /**
-     * Returns the text of this script. Returns an empty String if this script has no text. Never returns null.
-     */
-    String getText();
-
-    /**
-     * Returns the name to use for the compiled class for this script. Never returns null.
-     */
-    String getClassName();
-
-    /**
-     * Returns the source file for this script, if any. Returns null if there is no source file for this script.
-     */
-    File getSourceFile();
-
-    /**
-     * Returns the description for this script. Never returns null.
-     */
-    String getDisplayName();
-}
+/*
+ * Copyright 2008 the original author or authors.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+package org.gradle.groovy.scripts;
+
+import java.io.File;
+
+/**
+ * The source for the text of a script.
+ */
+public interface ScriptSource {
+    /**
+     * Returns the text of this script. Returns an empty String if this script has no text. Never returns null.
+     */
+    String getText();
+
+    /**
+     * Returns the name to use for the compiled class for this script. Never returns null.
+     */
+    String getClassName();
+
+    /**
+     * Returns the source file for this script, if any. Returns null if there is no source file for this script.
+     */
+    File getSourceFile();
+
+    /**
+     * Returns the canonical path of the source file for this script, if any. Returns null if there is no source file for this script.
+     */
+    String getSourceFileCanonicalPath();
+
+    /**
+     * Returns the description for this script. Never returns null.
+     */
+    String getDisplayName();
+}
Index: src/main/groovy/org/gradle/groovy/scripts/StrictScriptSource.java
===================================================================
--- src/main/groovy/org/gradle/groovy/scripts/StrictScriptSource.java	(revision 1596)
+++ src/main/groovy/org/gradle/groovy/scripts/StrictScriptSource.java	(working copy)
@@ -1,55 +1,59 @@
-/*
- * Copyright 2009 the original author or authors.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *      http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-package org.gradle.groovy.scripts;
-
-import org.gradle.api.GradleException;
-
-import java.io.File;
-
-public class StrictScriptSource implements ScriptSource {
-    private final ScriptSource source;
-
-    public StrictScriptSource(ScriptSource source) {
-        this.source = source;
-    }
-
-    public ScriptSource getSource() {
-        return source;
-    }
-
-    public String getText() {
-        File sourceFile = source.getSourceFile();
-        if (!sourceFile.exists()) {
-            throw new GradleException(String.format("Cannot read %s as it does not exist.", source.getDisplayName()));
-        }
-        if (!sourceFile.isFile()) {
-            throw new GradleException(String.format("Cannot read %s as it is not a file.", source.getDisplayName()));
-        }
-        return source.getText();
-    }
-
-    public String getClassName() {
-        return source.getClassName();
-    }
-
-    public File getSourceFile() {
-        return source.getSourceFile();
-    }
-
-    public String getDisplayName() {
-        return source.getDisplayName();
-    }
-}
+/*
+ * Copyright 2009 the original author or authors.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+package org.gradle.groovy.scripts;
+
+import org.gradle.api.GradleException;
+
+import java.io.File;
+
+public class StrictScriptSource implements ScriptSource {
+    private final ScriptSource source;
+
+    public StrictScriptSource(ScriptSource source) {
+        this.source = source;
+    }
+
+    public ScriptSource getSource() {
+        return source;
+    }
+
+    public String getText() {
+        File sourceFile = source.getSourceFile();
+        if (!sourceFile.exists()) {
+            throw new GradleException(String.format("Cannot read %s as it does not exist.", source.getDisplayName()));
+        }
+        if (!sourceFile.isFile()) {
+            throw new GradleException(String.format("Cannot read %s as it is not a file.", source.getDisplayName()));
+        }
+        return source.getText();
+    }
+
+    public String getClassName() {
+        return source.getClassName();
+    }
+
+    public File getSourceFile() {
+        return source.getSourceFile();
+    }
+
+    public String getSourceFileCanonicalPath() {
+        return source.getSourceFileCanonicalPath();
+    }
+
+    public String getDisplayName() {
+        return source.getDisplayName();
+    }
+}
Index: src/main/groovy/org/gradle/groovy/scripts/StringScriptSource.java
===================================================================
--- src/main/groovy/org/gradle/groovy/scripts/StringScriptSource.java	(revision 1596)
+++ src/main/groovy/org/gradle/groovy/scripts/StringScriptSource.java	(working copy)
@@ -1,60 +1,64 @@
-/*
- * Copyright 2008 the original author or authors.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *      http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-package org.gradle.groovy.scripts;
-
-import org.gradle.api.Project;
-import org.gradle.util.GUtil;
-import org.apache.commons.lang.builder.EqualsBuilder;
-import org.apache.commons.lang.builder.HashCodeBuilder;
-
-import java.io.File;
-
-public class StringScriptSource implements ScriptSource {
-    private final String description;
-    private final String content;
-
-    public StringScriptSource(String description, String content) {
-        this.description = description;
-        this.content = content;
-    }
-
-    public String getText() {
-        if (content == null) {
-            return "";
-        }
-        return content;
-    }
-
-    public String getClassName() {
-        return Project.EMBEDDED_SCRIPT_ID;
-    }
-
-    public File getSourceFile() {
-        return null;
-    }
-
-    public String getDisplayName() {
-        return description;
-    }
-
-    public boolean equals(Object obj) {
-        return EqualsBuilder.reflectionEquals(this, obj);
-    }
-
-    public int hashCode() {
-        return HashCodeBuilder.reflectionHashCode(this);
-    }
-}
+/*
+ * Copyright 2008 the original author or authors.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+package org.gradle.groovy.scripts;
+
+import org.gradle.api.Project;
+import org.gradle.util.GUtil;
+import org.apache.commons.lang.builder.EqualsBuilder;
+import org.apache.commons.lang.builder.HashCodeBuilder;
+
+import java.io.File;
+
+public class StringScriptSource implements ScriptSource {
+    private final String description;
+    private final String content;
+
+    public StringScriptSource(String description, String content) {
+        this.description = description;
+        this.content = content;
+    }
+
+    public String getText() {
+        if (content == null) {
+            return "";
+        }
+        return content;
+    }
+
+    public String getClassName() {
+        return Project.EMBEDDED_SCRIPT_ID;
+    }
+
+    public File getSourceFile() {
+        return null;
+    }
+
+    public String getSourceFileCanonicalPath() {
+        return null;
+    }
+
+    public String getDisplayName() {
+        return description;
+    }
+
+    public boolean equals(Object obj) {
+        return EqualsBuilder.reflectionEquals(this, obj);
+    }
+
+    public int hashCode() {
+        return HashCodeBuilder.reflectionHashCode(this);
+    }
+}
Index: src/test/groovy/org/gradle/configuration/BuildScriptCompilerTest.java
===================================================================
--- src/test/groovy/org/gradle/configuration/BuildScriptCompilerTest.java	(revision 1596)
+++ src/test/groovy/org/gradle/configuration/BuildScriptCompilerTest.java	(working copy)
@@ -1,99 +1,103 @@
-/*
- * Copyright 2009 the original author or authors.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *      http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-package org.gradle.configuration;
-
-import org.gradle.api.internal.artifacts.dsl.TaskDefinitionScriptTransformer;
-import org.gradle.api.internal.artifacts.dsl.BuildScriptClasspathScriptTransformer;
-import org.gradle.api.internal.project.ImportsReader;
-import org.gradle.api.internal.project.ProjectInternal;
-import org.gradle.api.internal.project.ProjectScript;
-import org.gradle.groovy.scripts.*;
-import static org.gradle.util.Matchers.*;
-import static org.hamcrest.Matchers.*;
-import org.jmock.Expectations;
-import org.jmock.integration.junit4.JMock;
-import org.jmock.integration.junit4.JUnit4Mockery;
-import org.jmock.lib.legacy.ClassImposteriser;
-import org.junit.Before;
-import org.junit.Test;
-import org.junit.runner.RunWith;
-
-import java.io.File;
-
-@RunWith(JMock.class)
-public class BuildScriptCompilerTest {
-    private final JUnit4Mockery context = new JUnit4Mockery() {{
-        setImposteriser(ClassImposteriser.INSTANCE);
-    }};
-    private final ProjectInternal project = context.mock(ProjectInternal.class);
-    private final ScriptSource scriptSource = context.mock(ScriptSource.class);
-    private final ScriptProcessorFactory scriptProcessorFactory = context.mock(ScriptProcessorFactory.class);
-    private final ScriptProcessor processor = context.mock(ScriptProcessor.class);
-    private final IProjectScriptMetaData projectScriptMetaData = context.mock(IProjectScriptMetaData.class);
-    private final ImportsReader importsReader = context.mock(ImportsReader.class);
-    private final ClassLoader classLoader = context.mock(ClassLoader.class);
-    private final ProjectScript classpathScript = context.mock(ProjectScript.class, "classpath");
-    private final ProjectScript buildScript = context.mock(ProjectScript.class, "build");
-    private final File rootDir = new File("root dir");
-    private final BuildScriptCompiler evaluator = new BuildScriptCompiler(importsReader, scriptProcessorFactory,
-            projectScriptMetaData);
-
-    @Before
-    public void setUp() {
-        context.checking(new Expectations() {{
-            allowing(project).getBuildScriptSource();
-            will(returnValue(scriptSource));
-
-            allowing(project).getRootDir();
-            will(returnValue(rootDir));
-
-            allowing(project).getBuildScriptClassLoader();
-            will(returnValue(classLoader));
-        }});
-    }
-
-    @Test
-    public void createsAndExecutesScriptAndNotifiesListener() {
-        final ScriptSource expectedScriptSource = new ImportsScriptSource(scriptSource, importsReader, rootDir);
-
-        context.checking(new Expectations() {{
-            one(scriptProcessorFactory).createProcessor(with(reflectionEquals(expectedScriptSource)));
-            will(returnValue(processor));
-
-            one(processor).setClassloader(classLoader);
-
-            one(processor).setTransformer(with(notNullValue(BuildScriptClasspathScriptTransformer.class)));
-
-            one(processor).process(ProjectScript.class);
-            will(returnValue(classpathScript));
-
-            one(projectScriptMetaData).applyMetaData(classpathScript, project);
-
-            one(classpathScript).run();
-
-            one(processor).setTransformer(with(notNullValue(TaskDefinitionScriptTransformer.class)));
-
-            one(processor).process(ProjectScript.class);
-            will(returnValue(buildScript));
-
-            one(projectScriptMetaData).applyMetaData(buildScript, project);
-
-            one(project).setBuildScript(buildScript);
-        }});
-
-        evaluator.evaluate(project);
-    }
+/*
+ * Copyright 2009 the original author or authors.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+package org.gradle.configuration;
+
+import org.gradle.api.internal.artifacts.dsl.TaskDefinitionScriptTransformer;
+import org.gradle.api.internal.artifacts.dsl.BuildScriptClasspathScriptTransformer;
+import org.gradle.api.internal.project.ImportsReader;
+import org.gradle.api.internal.project.ProjectInternal;
+import org.gradle.api.internal.project.ProjectScript;
+import org.gradle.groovy.scripts.*;
+import static org.gradle.util.Matchers.*;
+import static org.hamcrest.Matchers.*;
+import org.jmock.Expectations;
+import org.jmock.integration.junit4.JMock;
+import org.jmock.integration.junit4.JUnit4Mockery;
+import org.jmock.lib.legacy.ClassImposteriser;
+import org.junit.Before;
+import org.junit.Test;
+import org.junit.runner.RunWith;
+
+import java.io.File;
+
+@RunWith(JMock.class)
+public class BuildScriptCompilerTest {
+    private final JUnit4Mockery context = new JUnit4Mockery() {{
+        setImposteriser(ClassImposteriser.INSTANCE);
+    }};
+    private final ProjectInternal project = context.mock(ProjectInternal.class);
+    private final ScriptSource scriptSource = context.mock(ScriptSource.class);
+    private final ScriptProcessorFactory scriptProcessorFactory = context.mock(ScriptProcessorFactory.class);
+    private final ScriptProcessor processor = context.mock(ScriptProcessor.class);
+    private final IProjectScriptMetaData projectScriptMetaData = context.mock(IProjectScriptMetaData.class);
+    private final ImportsReader importsReader = context.mock(ImportsReader.class);
+    private final ClassLoader classLoader = context.mock(ClassLoader.class);
+    private final ProjectScript classpathScript = context.mock(ProjectScript.class, "classpath");
+    private final ProjectScript buildScript = context.mock(ProjectScript.class, "build");
+    private final File rootDir = new File("root dir");
+    private final BuildScriptCompiler evaluator = new BuildScriptCompiler(importsReader, scriptProcessorFactory,
+            projectScriptMetaData);
+
+    @Before
+    public void setUp() {
+        context.checking(new Expectations() {{
+            allowing(project).getBuildScriptSource();
+            will(returnValue(scriptSource));
+
+            allowing(project).getRootDir();
+            will(returnValue(rootDir));
+
+            allowing(project).getBuildScriptClassLoader();
+            will(returnValue(classLoader));
+
+            allowing(scriptSource).getSourceFileCanonicalPath();
+            will(returnValue(null));
+        }});
+    }
+
+    @Test
+    public void createsAndExecutesScriptAndNotifiesListener() {
+        final ScriptSource expectedScriptSource = new ImportsScriptSource(scriptSource, importsReader, rootDir);
+
+        context.checking(new Expectations() {{
+            one(scriptProcessorFactory).createProcessor(with(reflectionEquals(expectedScriptSource)));
+            will(returnValue(processor));
+
+            one(processor).setClassloader(classLoader);
+
+            one(processor).addTransformer(with(notNullValue(BuildScriptClasspathScriptTransformer.class)));
+
+            one(processor).process(ProjectScript.class);
+            will(returnValue(classpathScript));
+
+            one(projectScriptMetaData).applyMetaData(classpathScript, project);
+
+            one(classpathScript).run();
+
+            one(processor).clearTransformers();
+            one(processor).addTransformer(with(notNullValue(TaskDefinitionScriptTransformer.class)));
+
+            one(processor).process(ProjectScript.class);
+            will(returnValue(buildScript));
+
+            one(projectScriptMetaData).applyMetaData(buildScript, project);
+
+            one(project).setBuildScript(buildScript);
+        }});
+
+        evaluator.evaluate(project);
+    }
 }
\ No newline at end of file
